#include <AT91SAM7X256.H>
#include <lib_at91sam7x256.h>
#include <stdint.h> 
#include "spi.h"


const uint32_t NPCS_CODE_MASK[4] = { 0<<16, 1<<16, 3<<16, 7<<16 };

void SPI_SYSTEM_INIT(void){

// Configure pins
SPI_Configure_PIO_MAKS(SPI0_PORT,SPI0_PIO_MASK); // Enable the SPI pins required by the application
  
SPI_Configure(AT91C_BASE_SPI0, 
                  AT91C_ID_SPI0,
                  AT91C_SPI_MSTR |     //master MODE
				  AT91C_SPI_MODFDIS |  //Disable Mode Fault Detection
				  SPI_MULTI_DEVICE  |// SET MULTI DEVICE SUPORT
				  SPI_DLYBCT(1000, 48000000)
    );

	SPI_ConfigureNPCS(AT91C_BASE_SPI0, 0, 	//config CH0 (ADS7843)
                      SPI_MODE_0 |
					  SPI_8_BIT  | 
					  SPI_SCBR(1000000, 48000000)| 	 // 1MHZ Bus Speed
                      SPI_DLYBS(50000, 48000000) 
					   );

	

//	SPI_ConfigureNPCS(AT91C_BASE_SPI0, 1, 	//config CH1 (MMC/SD)
//                      AT91C_SPI_CPOL |
//					  AT91C_SPI_BITS_8 |
//					  SPI_SCBR(1000000, 48000000)| 	 // 1MHZ Bus Speed
//                      SPI_DLYBS(50000, 48000000) 
//					   );

    
  
   SPI_ConfigureNPCS(AT91C_BASE_SPI0, 2, 	//config CH2 (AD45DB161)
                      SPI_MODE_0 |
					  //AT91C_SPI_NCPHA |
					  SPI_8_BIT |
					  SPI_SCBR(1000000, 48000000)| 	 // 1MHZ Bus Speed
             		  SPI_DLYBS(50000, 48000000)
					   );

	
	SPI_Enable(AT91C_BASE_SPI0);
   
}


void SAMspiSetSCBR(unsigned char ch, unsigned char baudrate)
{
	unsigned int reg = 0;
	AT91PS_SPI pSPI   = AT91C_BASE_SPI0;

    ch &= 0x03; /* 0 ~ 3 */

	if ( baudrate < 2 ) baudrate = 2;
	if ( baudrate > 1 ) baudrate &= 0xFE;

	reg = pSPI->SPI_CSR[ch];
	reg = ( reg & ~(AT91C_SPI_SCBR) ) | ( (unsigned long)baudrate << 8 );
	pSPI->SPI_CSR[ch] = reg;
}


char spi(char channel,char dataToSend)
{
	int receivedData;
	
	while( !( AT91C_BASE_SPI0->SPI_SR & AT91C_SPI_TDRE ) );
	AT91C_BASE_SPI0->SPI_TDR = NPCS_CODE_MASK[channel] | dataToSend;
	
	while( !( AT91C_BASE_SPI0->SPI_SR & AT91C_SPI_RDRF ) );
	receivedData = (int)( AT91C_BASE_SPI0->SPI_RDR );
	
	return(receivedData);
}







